#ifndef WTNL
#define WTNL
//*************************************************************************//
//*****************  :************************//
#include "WTL.H"
//*************************************************************************//
//*****************  :****************************//
typedef struct {complex **Mas;integer n;integer m;} pcomplex;
//*************************************************************************//
//******* /    :******//
//    n-   m- 
pcomplex SET_PMAS(integer n,integer m) {
   pcomplex P;
   P.n=n;    P.m=m;
   P.Mas=(complex**)malloc(n*sizeof(complex*));
   for(integer i=0;i<n;i++) P.Mas[i]=(complex*)malloc(m*sizeof(complex));
   return P;
}
// 
void CLR_PMAS(pcomplex *P) {
   for(integer i=0;i<P->n;i++) free(P->Mas[i]);
   free(P->Mas);
}
//===========================================================================================
//    n-   m- 
pcomplex FWT(pcomplex Ish,scomplex *Filtr,integer p) {
    pcomplex P;
    scomplex Input,Output;
    Input.k=Ish.m;
    P=SET_PMAS(Ish.n,Ish.m);
    for(integer i=0; i<Ish.n; i++) {
        Input.Mas=Ish.Mas[i];
        Output=FWT(Input,Filtr,p);
        P.Mas[i]=Output.Mas;
    }
    return P;
}
//    n-   m- 
pcomplex IFWT(pcomplex Koeff,scomplex *Filtr,integer p) {
    pcomplex P;
    scomplex Input,Output;
    integer i,n,m;
    n=Koeff.n;  m=Koeff.m;
    Input.k=m;
    P=SET_PMAS(n,m);
    for(i=0; i<n; i++) {
        Input.Mas=Koeff.Mas[i];
        Output=IFWT(Input,Filtr,p);
        P.Mas[i]=Output.Mas;
    }
    return P;
}
//===========================================================================================
//   
pcomplex FWT(pcomplex Ish,scomplex *Filtr1,integer p1,scomplex *Filtr2,integer p2) {
    pcomplex P;
    scomplex Input,Output;
    integer i,j,n,m;

    n=Ish.n;    m=Ish.m;
    P=SET_PMAS(n,m);
    Input.k=m;
    for(i=0; i<n; i++) {
        Input.Mas=Ish.Mas[i];
        Output=FWT(Input,Filtr1,p1);
        P.Mas[i]=Output.Mas;
    }
    Input=SET_MAS(n);
    for(j=0; j<m; j++) {
        for(i=0; i<n; i++) Input.Mas[i]=P.Mas[i][j];
        Output=FWT(Input,Filtr2,p2);
        for(i=0; i<n; i++) P.Mas[i][j]=Output.Mas[i];
    }
    return P;
}
//   
pcomplex IFWT(pcomplex Koeff,scomplex *Filtr1,integer p1,scomplex *Filtr2,integer p2) {
    pcomplex P;
    scomplex Input,Output;
    integer i,j,n,m;

    n=Koeff.n;    m=Koeff.m;
    P=SET_PMAS(n,m);

    Input=SET_MAS(n);
    for(j=0; j<m; j++) {
        for(i=0; i<n; i++) Input.Mas[i]=Koeff.Mas[i][j];
        Output=IFWT(Input,Filtr2,p2);
        for(i=0; i<n; i++) P.Mas[i][j]=Output.Mas[i];
    }

    Input.k=m;
    for(i=0; i<n; i++) {
        Input.Mas=P.Mas[i];
        Output=IFWT(Input,Filtr1,p1);
        P.Mas[i]=Output.Mas;
    }
    return P;
}
#endif






